<HTML>
<HEAD>

<TITLE>History of the HEPiX startup scripts project ( 3-May-1995)</TITLE>
<!-- Changed by: Arnaud Taddei,  3-May-1995 -->

</HEAD>
<BODY>

<H1>History of the HEPiX startup scripts project</H1>
<HR>
<P>
The following is the History of the HEPiX scripts
project. It is given in reverse chronological order.
<P>
The numbering should be read as: Version.Release.Patch
<P>
<HR>
<P>
<H3>27 February 95: Version 2.5.1</H3>
<P>
This new version inaugurates the first <TT>HEP_Xsession</TT> scripts for AIX 
and Solaris.
It has a better support for group level and warn users if the system 
is unable to find the user group name. Indeed, it occured quite often that 
system administrators forget to update the <TT>/etc/group</TT> file or 
its NIS equivalent.
<P>
The following gives the list of upgrades which have been done:
<P>
<B>Shell part:</B>
<UL>
<LI> <I>wrappers:</I>
<BR> bug fix done: a branch test was missing, so the system wasn't 
     sourcing the right flags according to what found in 
     <TT>/etc/hepix/list-</TT>
<P>
<LI> <I>startup-scripts:</I> 
<UL>
<LI>improved group support, group level protection and group name calculation
<LI>fix the call to the zsh 'rc' part in HEP_zshenv. The shell is detected
with <TT>ZSH_VERSION</TT> now as <TT>VERSION</TT> is not supported anymore.
This is an uncompatibility which comes with zsh2.6.* versions.
</UL>
<P>
<LI> <I>site-customisation:</I> 
<UL>
<LI> remove the alias <B>x</B> -> <B>the</B>;
<LI> remove alias <B>ff</B> because of the discovery of an <B>f</B>f command 
     on AIX.
<LI> bug fix for <TT>DOMAINAME</TT> test in the bourne shells
<LI> add support for group level
<LI> add <TT>CERN</TT>, <TT>CERN_ROOT</TT>, <TT>CERN_LEVEL</TT> variables + 
     othe system specific variables like <TT>TZ</TT>, <TT>ODMDIR</TT>, 
     <TT>LANG</TT>, <TT>NLSPATH</TT>, <TT>LOCPATH</TT>. 
     Correction to the Solaris <TT>SYSPATH</TT>, <TT>/usr/ucb</TT> is now at 
     the end.
<LI> introduction of the <TT>LOCAL_MAIL</TT> variable which points to the 
     local mailbox
<LI> extended <TT>XFILESEARCHPATH</TT> variable
<LI> unset the '<TT>autologout</TT>' parameter for <B>tcsh</B>
<LI> unset the <TT>TMOUT</TT> variable for <B>zsh</B>
</UL>
<P>

<LI> <I>templates:</I>
<UL>
<LI> remove the example with <TT>ORACLE/bin</TT> because it might be confusing,
<LI> remove the example with <B>do_xauth</B> because not deployed at CERN,
<LI> add an example in order to replace the <B>ff</B> alias: <B>findfile</B>
<LI> add a forward, <TT>rhosts</TT>, <TT>pinerc</TT> template,
</UL>
<P>
<LI> <I><B>uco</B> - Claudia Bondila claud@cernapo.cern.ch:</I>
<UL>
<LI> add a <TT>-l</TT> flag to link shared executables in all 
     <TT>.@sys/bin</TT> repositories
<LI> add a <TT>-h</TT> help flag
<LI> add a <TT>-R</TT> flag for <TT>.rhosts</TT> file
<LI> add a <TT>-m</TT> support for dumping the <TT>.pinerc</TT> default file
<LI> the <TT>-p</TT> flag has to be used alone: '<TT>uco -p</TT>' calculates 
     your login shell and dumps the right profile files accordingly,
<LI> the '<TT>-q shell</TT>' option enables you to specify the shell for 
     which you want to get back the default profiles files,
</UL>
<P>	
<LI> <I>make.pl:</I>
<BR>
had been modified quite a lot in order to answer the basic following questions
<UL>
<LI> Do you want to enforce the scripts (default) or not (<TT>-w</TT> flag),
<LI> Do you want to put only the shell part (default) or both shell and X11 
     part (<TT>-X</TT> flag)
<LI> Do you want to put the inproduction mode (default) or the debug mode 
     (<TT>-d</TT> flag)
</UL>
<P>
Of course the <TT>-v</TT> flag exists as well in order to have the verbose mode
<P>
The program checks if the file systems are writable before doing anything and
asks you to correct or not the situation. Indeed you might want to share some 
files onto an exported NFS filesystem, or an AFS filesystem, etc.
<P>
(For sys admin who are using ASIS, don't forget to run <B>ASISUpdate</B> 
if you had to make some directories local, <TT>/usr/local/lib/hepix</TT> or 
<TT>/usr/local/lib/X11/xdm</TT>, <TT>/usr/local/man/man1</TT>,
/usr/local/bin, etc.)
<P>
It exists anyway a <TT>-F</TT> option to Force the installation.
<P>
In the future will come a <TT>-u</TT> option to specify if you want to 
have the <B>uco</B> function and man pages local or remote. 
Other important improvements and rationalisation will come.
</UL>



<B>X11:</B>
<P>
The X11 support starts with this version, It is available only for 
AIX and Solaris but the other platforms will be added to the list.
<P>
It gives a set of files <TT>HEP_Xsession</TT>, <TT>HEP_Xclients</TT>, etc. 
in order to have a minimal working access to the <B>xdmcp</B> services.
<P>
This provide a hook for sys admin tasks, like <TT>/etc/nologin</TT>, it 
provides an work environment in order to know what is the <TT>HEP_WM</TT> 
(window manager), the User resources files, group files, client files, etc. 
<P>
It has a failsafe mode: while in the login panel, after you 
entered your login name, enter your password and instead of entering 
<TT>carriage return</TT>, enter <TT>F1</TT>, you will get a <I>failsafe</I> 
mode.
<P>
It creates a log in the user <TT>HOME</TT> directory: <TT>.xdm-stderr</TT> and 
<TT>.xdm-stdout</TT>
<P>
It calculates the login shell and split the <TT>Xsession</TT> into sub 
parts according to your login shell. This means that it runs then into 
the same environment as the user login environment.
<P>
If the user has a <TT>.xsession</TT> file it runs it and assumes the user 
knows what he is doing. Otherwise, the file <TT>.Xclients</TT> 
is used by the user to specify the list of programs he wants to 
start at beginning. The file <TT>.xsession.env</TT> can be used to specify 
the value of <TT>HEP_WM</TT>. If the latter equals '<TT>local</TT>' 
then no window manager is started but the local window manager can be used.
<P>
This is under rapid evolution but you can already play with it.
<P>
<HR>
<H3>5 December 94: Version 2.5</H3>
<P>
The first in production release of the hepix project in the AFS Cell.
<P>
<HR>
<H3>21 November 94: Version 2.4.12</H3>
<P>
This version had been tested but not put into production it had been 
skipped in favour of release 2.5
<UL>
<LI> last update of the user templates
<LI> last improvement of the <B>make.pl</B>
<LI> last improvement of the ftp repository
<LI> correction to the <TT>copyright/motd</TT> sequence in <TT>login.[c]sh</TT>
<LI> eliminate the '<B>mail</B>' alias
<LI> make a clean separation between installation mode 1 and mode 2.
     In mode 1 don't start anything under <TT>/etc</TT> now because of 
     the nasty HP!
<LI> introduce a first beta version of the hepix 2 project with a 
     <I>Xwrapper</I> and a <I>X-HEP-level</I> domain: 
     first design of a <TT>HEP_Xsession</TT>.
</UL>
<HR>
<H3>15 November 94: Version 2.4.11</H3>
<P>
<UL>
<LI> improvement of the <B>make.pl</B>: create a verbose mode
<LI> introduction of the ftp repository 

</UL>
<HR>
<P>
<H3>9 November 94: Version 2.4.10</H3>
<UL>
<LI> improvement of the <B>zsh</B> user templates
<LI> improvement of the <B>make.pl</B> and the installation procedure
</UL>
<HR>
<P>
<H3>18 October 94: Version 2.4.9</H3>
<UL>
<LI> Implementation of the <TT>CLUSTER</TT> level. 
     It should increase the efficiency.
<LI> There is now a <TT>/afs/cern.ch/project/hepix</TT> volume so there 
     are some modifications for the installation of Beta versions.
<LI> uco is reviewed to get the '<TT>-p shell</TT>' option instead 
     of only '<TT>-p</TT>', etc.
</UL>
<HR>
<P>
<H3>10 October 94: Version 2.4.8</H3>
<P>
At least, the <TT>sys.conf</TT> files can call other levels files so we don't 
need to support different models but only one for CERN! 
It clarifies the situation and then we can add a <TT>CLUSTER</TT> level instead
of the <TT>coreconf</TT> file.
<HR>
<P>
<H3>7 October 94: Version 2.4.7</H3>
<UL>
<LI> <B>uco</B> is in progress
<LI> the file <TT>HEP_kshrc</TT> is protected because it can be sourced 
     by <TT>.kshrc</TT> and it calls this file.
<LI> all the protections are improved in the same time.
</UL>
<HR>
<P>
<H3>6 October 94: Version 2.4.6</H3>
<UL>
<LI> NQS is tested, bug fix in C-shells: use the <TT>status</TT> of the 
     '<TT>tty -s</TT>' 
     command instead of the prompt because the shell is started in login mode.
<LI> Problem with the fact that PDP is using yet another <TT>OS</TT> 
     definition! So a '<TT>/bin/test -s mail</TT>' is called and it is an 
     HP posix-shell call!
<LI> <TT>ENVIRONMENT</TT> is reviewed.
<LI> Documentation for the templates is written.
</UL>
<HR>
<P>
<H3>29 September 94: Version 2.4.5</H3>
<P>
<UL>
<LI> <TT>uco.1</TT> man pages for uco written
<LI> templates are better now and evaluated by Startup_scripts mailing list
<LI> the <TT>TERM</TT> variable bug is corrected for L3 (and for everybody) 
     as they are using the DESY <B>xrlogin</B> to pass the <TT>DISPLAY</TT> 
     variable.
<LI> the call to the group level is done in all files at the model level.
</UL>
<HR>
<P>
<H3>27 September 94: Version 2.4.4</H3>
<P>
<UL>
<LI> First Introduce In Production on ASIS
<P>
<LI> <I>debug mode:</I>
     <BR> The debug mode is improved. Everything goes into a file 
     <TT>/tmp/hepix-log.$$</TT>
<P>
<LI> Central-Beta is introduced so the scripts can be tested in beta version
     by everybody on ASIS.
<P>
<LI> <I>templates</I>:
     <BR> <B>oracle</B> call is put in <TT>oracle_*.[c]sh</TT> files; 
     the user has no "hard" line in his template. M. Marquina's input.
<LI> <I>wrappers:</I>
     <BR> users with <TT>uid</TT> < 100 are not getting the HEPiX environment.
<P>
<LI> <I> site customisation:</I>
     <BR> <TT>coreconf</TT> is sourced for every body. 
     Will be improved in 2.4.9, 
     A lot of PDP's model is merged with DCI's model.
<P>
<LI> <TT>tools:</TT>
     <BR> <TT>Makefile</TT> is improved again
</UL>
<HR>
<P>
<H3>20 September 94: Version 2.4.3</H3>
<UL>
<LI> <I>Meeting about the location of the scripts:</I>
<PRE>
	/usr/sue/etc       -> /usr/local/lib/hepix
	/usr/sue/etc/local -> /etc/hepix
</PRE> 
<LI> <I>Site customisation: </I>
<UL>
<LI> <TT>PASSWORD_EXPIRES</TT> is checked for AFS
<LI> <TT>coreconf</TT> introduced for PDP's adaptation
<LI> <TT>hpterm</TT> fixed for <B>ksh</B>, <B>tcsh</B>, <B>bash</B>, 
     <B>zsh</B>: can use the arrows as on <B>xterm</B>
</UL>
<P>
	 
<LI> <I>wrappers:</I>
     <BR> <TT>root</TT> is excluded fully
<P>
<LI> <I>templates:</I>
<UL>
<LI> improved with some text
<LI> <B>oracle</B> is added
</UL>
<P>
<LI> <I>tools:</I>
<UL>
<LI> <TT>Makefile</TT> improved
<LI> <B>uco</B> command introduced
</UL>

</UL>
<HR>
<P>
<H3>16 August 94: Version 2.4.2</H3>
<UL>
<LI> <I>central templates:</I> 
     <BR> gets the today's form. They try to get some informations
     about the shell variables which protect the HEP files. Don't do
     anything if these shell variables are set.
<P>
<LI> <I>startup scripts: </I>
     <BR> each of the following files are protected by shell variables
     <TT>HEP_cshenv</TT>, <TT>HEP_shenv</TT>, <TT>HEP_login</TT>, 
     <TT>HEP_profile</TT> So we know if they have been already 
     executed or not. Can't be done twice!
<P>
<LI> <I>templates: </I>
     <BR> improved
</UL>
<HR>
<P>
<H3>1 August 94: Version 2.4.1</H3>
<P>
Major changements at CERN:
<P>
<OL>
<LI> <I>There are different ways to install the HEP scripts</I>
<UL>
<LI> the scripts can be enforced on a system. 
     So some wrappers have been defined.     
<LI> the scripts can be available on a system
     So some <TT>central_*.[c]sh</TT> files have been designed.
</UL>
<P>
<LI> <I>Not everybody is using the scripts</I>
     <BR> <TT>root</TT>, <TT>adm</TT>, all users in 
     <TT>/usr/sue/etc/local/list-</TT>
<P>
<LI> <I>The scripts are now compiled with a debug mode</I>
<UL>
<LI> From a central source repository where the HEP scripts are a put 
     in a domain, the files are compiled into a debug and an inproduction mode.
<LI> The compilation overcomes the <TT>~/bin/whoami</TT> bug
     where <B>whoami</B> is redefines the unix command. 
     All the unix commands are compiled with their absolute name in the 
     HEP scripts.
<LI> The debug mode is produced automatically from the instrumented
     code in the source repository. It shows what files are opened 
     in what order.
<LI> The parse algorithm is changed and replaced by a simple source 
     of the <TT>sys.conf</TT> file which are compiled as well. Thus we don't
     need the <TT>OS</TT> extension but the shell flavour extension <B>csh</B>
     or <B>sh</B>.
</UL>
<P>
<LI> <I>Everything should go with SUE so:</I>
<UL>
<LI> the HEP files should go in <TT>/usr/sue/etc</TT> instead of <TT>/etc</TT>
<LI> the system adaptation should go in <TT>/usr/sue/etc/local</TT>
<LI> the site customisation level (previously in <TT>/etc/local</TT>)
     should go in <TT>/usr/sue/etc</TT>
</UL>
<P>
	  
<LI> <I>Levels:</I>
     <BR> Need a Site or Model level instead of only a system level:
<UL>
<LI> HEP level
<LI> Site or Model level
<LI> System level
<LI> Group Level 
<LI> User level
</UL>
Unfortunately there is no one CERN adaptation but there are 
MODELS adaptation (TH, WWW, DXCERN, PDP, L3, etc.) because
they are not using AFS fully. This problem will be solved in 2.4.8.
<P>
<LI> <I>Headers:</I>
     <BR> All the headers of files have been standardised in a clean way.
<P>
<LI> <I>Files:</I>
<UL>
<LI> <I>startup files (HEP level):</I>
<UL>
<LI> All the files are calling some files in the site or model level.
<LI> redefines <TT>ENVIRONMENT</TT> in <TT>HEP_cshenv</TT>, 
     <TT>HEP_shenv</TT>, <TT>HEP_login</TT>, <TT>HEP_profile</TT>
<LI> all the names will be changed to their actual shell name but with 
     <TT>HEP_</TT> in front of them at make/compile time:
<PRE>
	HEP_cshenv  -> HEP_csh.cshrc
	HEP_login   -> HEP_csh.login
	HEP_shenv   -> HEP_zshenv
	HEP_profile -> HEP_zprofile
</PRE>
</UL>

	    
<LI> <I>central files:</I> 
     <BR> a lot of specific lines to compensate 
<UL>
<LI> <B>csh</B> defficiencies
<LI> <TT>ENVIRONMENT</TT> unset properly
<LI> <TT>BATCH</TT> mode in <B>xrsh</B>
</UL>
<P>
<LI> site customisation or model level files:
<UL>
<LI> all files are calling the system adaptation files but the 
     <TT>sys.conf</TT> files
<LI> <TT>zshrc</TT>: called by <TT>HEP_zshrc</TT> at the HEP level. 
<UL>
<LI> unalias <B>pwd</B> and unset <TT>HISTFILE</TT>
<LI> is calling the system adaptation file. unset all the options.
</UL>
	      
<LI> <TT>kshrc</TT>: includes some lines from R. Toebbicke <TT>kshrc</TT> file
</UL>
<P>
<LI> <I>templates:</I> they are very small but growing!
</UL>



</OL>
<HR>
<P>
<H3>17 June 94: Version 2.4</H3>
<P>
<UL>
<LI> new parsing algorithm for <TT>sys.conf</TT> 
     (now you can evaluate variables like 
     <TT>INITIALE=`echo $USER | cut -c1`</TT> )
<LI> some changes in <TT>termset.[c]sh</TT>
</UL>
<HR>
<P>
<H3>5 May 94:</H3>
<P>
<UL>
<LI> <TT>SYSTYPE</TT> changed to "<TT>sysV</TT>" or "<TT>bsd</TT>"
<LI> fix for the problem  "<TT>BASH_VERSION: parameter not set</TT>" 
     in scripts with the line <TT>#!/bin/ksh -uhf</TT>
<LI> additional setting of 
     <TT>BINTYPE</TT>,<TT>SYSTYPE</TT>,<TT>MANPATH</TT> for missing 
     <TT>sys.conf</TT>
<LI> echo message for missing <TT>sys.conf</TT> only for interactive usage 
<LI> bugfix in <TT>TERM</TT> setting (<TT>HEP_login</TT> )
</UL>
<HR>
<P>
<H3>13 April 94: </H3>
<UL>
<LI> new keybindings and options in <TT>zshrc</TT>
<LI> . in cdpath (<TT>tcshrc,zshrc</TT>) added
<LI> improved prompt setting in <B>csh</B>
<LI> prompt setting only in <TT>HEP_shenv</TT>	
<LI> <TT>SH</TT> setting in <TT>Makefile</TT>
</UL>
<HR>
<P>
<H3>26 March 94: Version 2.2</H3>
<UL>
<LI> improved scan algorithm for <TT>sys.conf</TT> in the C shell flavour
<LI> no search for <TT>$HOME/bin</TT> and <TT>$HOME/bin.$BINTYPE</TT>	
<LI> changed <TT>PATH</TT> syntax with spaces as seperator
<LI> history file name changed to <TT>$HOME/.history.$HOST</TT>
<LI> usage of the id instead of the groups command
<LI> new alias name pp instead of psg
<LI> introduction of a separate root search path (<TT>ROOTPATH</TT> variable in
     <TT>sys.conf</TT>) 
<LI> alias <B>rs</B> for <B>resize</B> command
</UL>
<HR>
<P>
<H3>09 Feb 94: Version 2.1</H3>
<P>
HEP_files HEP startup set a complete rewrite of setup file
<P>
<PRE>	</PRE>- <B>first version agreed with CERN</B> -
<P>
There is a file called <B>sys.conf</B> in which you can put all
the environment variables and it will be parsed from all 
shells.
<P>
There is also a <TT>Makefile</TT> to install the startup files
in your home directory for tests or as a global environment.
<HR>
<P>
<H3>13 Aug 93: Version 1.0.4</H3>
<UL>
<LI> <TT>zshenv: </TT>
     <BR> <TT>/usr/etc</TT> included in <TT>PATH</TT> for all users
     new variable <TT>LESSCHARSET</TT>, which is set to "<TT>latin1</TT>"
     aliases <B>ls</B>,<B>la</B>,<B>ll</B>,<B>lsize</B> and <B>lt</B> corrected
<P>
<LI> <TT>zprofile: </TT>
     <BR> <B>stty</B> command modified for all operating systems
     to support 8 bit input/output on <B>tty</B>
     only for HP-UX: <TT>eval `resize`</TT>
<P>
<LI> <TT> zshrc:  </TT>
     <BR> support completion for new <B>zsh</B> versions
     completions like <B>tcsh</B>
     options <TT>extendedglob</TT> and <TT>recexakt</TT> deleted
     options <TT>completeinword</TT> and <TT>appendhistory</TT> set 
<P>
<LI> <TT>csh.cshrc: </TT>
     <BR> <TT>/usr/etc</TT> included in<TT> PATH</TT> for all users	
     new variable <TT>LESSCHARSET</TT>, which is set to "<TT>latin1</TT>"
     new alias <B>pwd</B> to show the user not the mountpoint
     of the automounted filesystem, but the path, which
     is of interest to the user
<P>
<LI> <TT> csh.login:</TT> 
     <BR> <B>stty</B> command modified for all operating systems
     to support 8 bit input/output on tty
     only for HP-UX: <TT>eval `resize`</TT>
<P>
<LI> <TT>tcshrc: </TT>
     <BR> completion modified  ( <B>zcat</B> )	
     completion only for new <B>tcsh</B> versions
</UL>
<HR>
<P>
<H3>07 Jun 93: Version 1.0.3</H3>
<UL>
<LI> <TT>zshenv: </TT>
     <BR> aliases <B>lt</B> and <B>lsize</B> corrected
     <TT>SAVEPATH</TT> introduced to restore the <TT>PATH</TT>
     after <TT>su</TT>
<P>
<LI> <TT>zprofile: </TT>
     <BR> correct bug in setting of <TT>TERM </TT>
     switch to application keyboard mode for <TT>vt*</TT> and <TT>xterm*</TT>
     handling of <TT>DISPLAY</TT> variable removed
     see explanation in <TT>README.profiles</TT>
     <B>resize</B> screen ( bug in HP-UX )
<P>
<LI> <TT>csh.cshrc: </TT>
     <BR> see <TT>zshenv</TT>
<P>
<LI> <TT>csh.login</TT>: 
     <BR> see <TT>zprofile</TT>
</UL>
<HR>
<P>
<H3>29 Apr 93: Version 1.0.2</H3>
<UL>
<LI> <TT>zshenv: </TT>
     <BR> <TT>/etc/kshrc</TT> and <TT>$HOME/.kshrc</TT> get source
     replace aliases by functions
     change <TT>PATH</TT> for IRIX 5.0
<P>
<LI> <TT>zprofile: </TT>
     <BR> <B>stty</B> command modified for DomainOS
     bug in testing <TT>$RUBOUT</TT> corrected
<P>
<LI> <TT>kshrc</TT> and <TT>.kshrc</TT> added
<P>
<LI> <TT>csh.cshrc:</TT> 
     <BR> initial system path defined
     prompts changed other test for mail in IRIX, DomainOS and HP-UX
     change path for IRIX 5.0
<P>
<LI> <TT>csh.login:</TT> 
     <BR> bug for IRIX <B>rlogin</B>s corrected	
     <B>stty</B> command modified for DomainOS
</UL>
<HR>
<P>
<H3>27 Apr 93: Version 1.0.1</H3>
<P>
Check <TT>termcap</TT> file for <TT>TERM</TT> type
<HR>
<P>
<H3>16 Apr 93: Version 1.0.0</H3>
<P>
Initial release of the startup scripts very preliminary !!! 
<P>
tested in <B>csh</B>, <B>tcsh</B> (<B>csh</B> like scripts)
tested in <B>sh</B>, <B>bash</B>, <B>ksh</B>, <B>zsh</B> (bourne like scripts)
<P>
on the following machines
<UL>
<LI> IBM RS6000 under AIX 3.2
<LI> HP 9000/730 under HP-UX 8.07
<LI> SGI 4D/460 under IRIX 4.0.5
<LI> Convex 3210 under ConvexOS 10.1
<LI> Sparcstation 10/30 under SunOS 4.1.3
<LI> DEC 5000/125 under ULTRIX
</UL>

	
<HR>

<ADDRESS> <A Name=Signature HREF="http://xwho.cern.ch/WHO/people/26840">Arnaud Taddei</A></ADDRESS>
</BODY>
</HTML>
